--- groff-1.18.orig/src/include/config.hin
+++ groff-1.18/src/include/config.hin
@@ -145,3 +145,9 @@
 /* Define uintmax_t to `unsigned long' or `unsigned long long' if <inttypes.h>
    does not exist. */
 #undef uintmax_t
+
+/* Define if you want to use Japanese extension. */
+#undef NIPPON
+
+/* Define if you have a nl_langinfo(CODESET). */
+#undef HAVE_LANGINFO_CODESET
--- groff-1.18.orig/src/include/device.h
+++ groff-1.18/src/include/device.h
@@ -18,4 +18,9 @@
 with groff; see the file COPYING.  If not, write to the Free Software
 Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
 
+#ifndef _DEVICE_H
+#define _DEVICE_H
+
 extern const char *device;
+
+#endif /* _DEVICE_H */
--- groff-1.18.orig/src/include/driver.h
+++ groff-1.18/src/include/driver.h
@@ -27,6 +27,7 @@
 #include <errno.h>
 #include <assert.h>
 #include <math.h>
+#include "encoding.h" // XXX: ukai
 #include "errarg.h"
 #include "error.h"
 #include "font.h"
--- groff-1.18.orig/src/include/font.h
+++ groff-1.18/src/include/font.h
@@ -18,6 +18,8 @@
 with groff; see the file COPYING.  If not, write to the Free Software
 Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
 
+#include "encoding.h"
+
 typedef void (*FONT_COMMAND_HANDLER)(const char *, const char *,
 				     const char *, int);
 
@@ -53,6 +55,9 @@
   const char *get_special_device_encoding(int index);
   const char *get_name();
   const char *get_internal_name();
+#ifdef	NIPPON
+  const char *get_subfont_name(int index);
+#endif
 
   static int scan_papersize(const char *, const char **, double *, double *);
 
@@ -62,6 +67,9 @@
   static int load_desc();
   static int name_to_index(const char *);
   static int number_to_index(int);
+#ifdef	NIPPON
+  static int wchar_index(wchar);
+#endif
   static FONT_COMMAND_HANDLER
     set_unknown_desc_command_handler(FONT_COMMAND_HANDLER);
 
@@ -76,6 +84,10 @@
   static int spare2;
   static int sizescale;
   static int tcommand;
+#ifdef	NIPPON
+  static int lowerwchar;
+  static int wcharkern;
+#endif
   static int pass_filenames;
   static int use_charnames_in_special;
 
@@ -83,6 +95,9 @@
   static const char **style_table;
   static const char *family;
   static int *sizes;
+#ifdef	NIPPON
+  static const char **on_demand_fonts;
+#endif
 private:
   unsigned ligatures;
   font_kern_list **kern_hash_table;
--- groff-1.18.orig/src/include/lib.h
+++ groff-1.18/src/include/lib.h
@@ -88,8 +88,15 @@
 
 extern char invalid_char_table[];
 
+#include "encoding.h" /* XXX: ukai */
+
 inline int invalid_input_char(int c)
 {
+#ifdef NIPPON
+  if (encoding->is_wchar_byte(c))
+      return 0;
+  else
+#endif
   return c >= 0 && invalid_char_table[c];
 }
 
--- groff-1.18.orig/src/include/printer.h
+++ groff-1.18/src/include/printer.h
@@ -38,6 +38,8 @@
 
 #include "color.h"
 
+#include "encoding.h"
+
 struct environment {
   int fontno;
   int size;
@@ -63,6 +65,9 @@
   printer();
   virtual ~printer();
   void load_font(int i, const char *name);
+#ifdef	NIPPON
+  void set_wchar_char(wchar c, const environment *env, int *widthp = 0);
+#endif
   void set_ascii_char(unsigned char c, const environment *env,
 		      int *widthp = 0);
   void set_special_char(const char *nm, const environment *env,
--- groff-1.18.orig/src/include/encoding.h
+++ groff-1.18/src/include/encoding.h
@@ -0,0 +1,157 @@
+// -*- C++ -*-
+/* Copyright (c) 2001 Fumitoshi UKAI <ukai@debian.or.jp>
+
+This file is part of groff.
+
+groff is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2, or (at your option) any later
+version.
+
+groff is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+
+#ifndef ENCODING_H
+#define ENCODING_H
+
+#include <config.h>
+
+#ifdef NIPPON
+typedef unsigned int wchar;
+#else
+typedef char wchar;
+#endif
+
+#include <stdio.h>
+
+#ifdef __cplusplus
+class encoding_istream {
+public:
+  encoding_istream() {};
+  virtual ~encoding_istream() {};
+  virtual int getbyte() = 0;
+  virtual int peekbyte() = 0;
+  virtual void ungetbyte(int ch) = 0;
+};
+
+class encoding_istream_str: public encoding_istream {
+private:
+  const unsigned char *s;
+  int *i;
+  encoding_istream_str() {};
+public:
+  encoding_istream_str(const unsigned char *s0, int *i0) : s(s0), i(i0) {};
+  ~encoding_istream_str() {};
+  inline int getbyte() { return s[(*i)++]; };
+  inline int peekbyte() { return s[(*i)]; };
+  inline void ungetbyte(int ch) { --(*i); };
+};
+
+class encoding_istream_fp: public encoding_istream {
+private:
+  FILE *fp;
+public:
+  encoding_istream_fp(FILE *fp0) : fp(fp0) {};
+  ~encoding_istream_fp() {};
+  inline int getbyte() { return fgetc(fp); };
+  inline int peekbyte() { int ch = fgetc(fp); ungetc(ch, fp); return ch; };
+  inline void ungetbyte(int ch) { ungetc(ch, fp); };
+};
+
+class encoding_ostream {
+public:
+  encoding_ostream() {};
+  virtual ~encoding_ostream() {};
+  virtual void putbyte(unsigned char ch) = 0;
+};
+
+class encoding_ostream_str: public encoding_ostream {
+private:
+  unsigned char *s;
+  int *i;
+  int len;
+  encoding_ostream_str() {};
+public:
+  encoding_ostream_str(unsigned char *s0, int *i0, int max) : s(s0), i(i0), len(max) {};
+  ~encoding_ostream_str() {};
+  inline void putbyte(unsigned char ch) {
+    if (*i < len)
+      s[(*i)++] = ch;
+  }
+};
+
+class encoding_ostream_fp: public encoding_ostream {
+private:
+  FILE *fp;
+  const char *format;
+public:
+  encoding_ostream_fp(FILE *ofp, const char *fmt = "%c") : fp(ofp), format(fmt) {};
+  ~encoding_ostream_fp() {};
+  inline void putbyte(unsigned char ch) {
+    fprintf(fp, format, ch);
+  }
+};
+
+class encoding_handler {
+protected:
+  wchar wc;
+public:
+  encoding_handler() {};
+  virtual ~encoding_handler() {};
+
+  virtual int is_wchar_code(wchar wc) { return 0; };
+  virtual int is_wchar_byte(unsigned char c) { return 0; };
+  virtual wchar make_wchar(unsigned char c0, encoding_istream& in) {
+    return wchar(c0);
+  }
+  virtual wchar make_wchar(unsigned char c0, FILE *fp) { 
+    encoding_istream_fp in(fp);
+    return make_wchar(c0, in);
+  }
+  virtual wchar make_wchar(unsigned char c0, const unsigned char *s, int *i) {
+    encoding_istream_str in(s, i);
+    return make_wchar(c0, in); 
+  }
+
+  virtual int put_wchar(wchar wc, encoding_ostream& out) {
+    out.putbyte((unsigned char)wc);
+    return 1;
+  }
+
+  virtual int put_wchar(wchar wc, FILE *fp, const char *fmt = "%c") {
+    encoding_ostream_fp out(fp, fmt);
+    return put_wchar(wc, out);
+  }
+  virtual int put_wchar(wchar wc, unsigned char *s, int *i, int maxlen) {
+    encoding_ostream_str out(s, i, maxlen);
+    return put_wchar(wc, out);
+  }
+  virtual int max_wchar_len() { return 1; };
+
+  virtual void foreach_wchar(void (*iter)(wchar wc, void *arg), void *arg) {};
+  virtual int wchar_iter_first(wchar *wc) { return 0; };
+  virtual int wchar_iter_next(wchar *wc) { return 0; };
+
+  // for indexer
+  virtual int wchar_index(wchar wc) { return 0; };
+  virtual void set_wchar_index(wchar wc, int index) { return; };
+
+  // for troff/input.cc
+  virtual int wchar_table_index(wchar wc) { return 0; };
+  virtual void* init_table() { return NULL;};
+};
+
+encoding_handler* new_encoding_handler(const char* encoding_name);
+extern encoding_handler* encoding;
+encoding_handler *init_encoding_handler();
+
+#endif
+
+#endif ENCODING_H
+
--- groff-1.18.orig/src/include/eucmac.h
+++ groff-1.18/src/include/eucmac.h
@@ -0,0 +1,88 @@
+// -*- C++ -*-
+/* Copyright (C) 1994 Free Software Foundation, Inc.
+     Written by Toshiyuki Kitagawa (kitagawa@bsd2.kb.nec.co.jp)
+
+This file is part of groff.
+
+groff is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2, or (at your option) any later
+version.
+
+groff is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+You should have received a copy of the GNU General Public License along
+with groff; see the file COPYING.  If not, write to the Free Software
+Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
+
+
+#ifndef _EUCMAC_H
+#define _EUCMAC_H
+
+#include <string.h>
+#include "device.h"
+
+#ifdef NIPPON
+typedef unsigned int	wchar;
+#else
+typedef char	wchar;
+#endif
+
+static const int WCTABLE_OFFSET = 0xa1;
+static const int WCTABLE_SIZE = 94;
+static const int EUCMASK = 0x8080;
+
+
+inline int is_euc_code(wchar wc)
+{
+  if ( device ) {
+       if ((strncmp(device, "latin1", 6) == 0) ||
+           (strncmp(device, "ascii8", 6) == 0)) {
+               return(0);
+       }
+  }
+  return((wc & EUCMASK) == (wchar)EUCMASK);
+}
+
+inline int is_euc_byte(unsigned char c)
+{
+  if ( device ) {
+       if ((strncmp(device, "latin1", 6) == 0) ||
+           (strncmp(device, "ascii8", 6) == 0)) {
+               return(0);
+       }
+  }
+  return(c >= 0xa1 && c <= 0xfe);
+}
+
+inline wchar make_euc_code(unsigned char ubyte, unsigned char lbyte)
+{
+  wchar wc;
+
+  wc = (ubyte & 0xff) << 8;
+  wc |= (lbyte & 0xff);
+  return(wc);
+}
+
+inline unsigned int euc_ubyte(wchar wc)
+{
+  return((unsigned int)((wc >> 8) & 0xff));
+}
+
+inline unsigned int euc_lbyte(wchar wc)
+{
+  return((unsigned int)(wc & 0xff));
+}
+
+inline wchar calc_euccode(int ku, int ten)
+{
+  wchar code = 0;
+
+  code = ((ku + WCTABLE_OFFSET) << 8) & 0xff00;
+  code |= (ten + WCTABLE_OFFSET) & 0xff;
+  return (code);
+}
+#endif	/* _EUCMAC_H */
--- groff-1.18.orig/src/libs/libgroff/Makefile.sub
+++ groff-1.18/src/libs/libgroff/Makefile.sub
@@ -6,6 +6,7 @@
   color.o \
   cset.o \
   device.o \
+  encoding.o \
   errarg.o \
   error.o \
   fatal.o \
@@ -45,6 +46,7 @@
   $(srcdir)/color.cc \
   $(srcdir)/cset.cc \
   $(srcdir)/device.cc \
+  $(srcdir)/encoding.cc \
   $(srcdir)/errarg.cc \
   $(srcdir)/error.cc \
   $(srcdir)/fatal.cc \
--- groff-1.18.orig/src/libs/libgroff/font.cc
+++ groff-1.18/src/libs/libgroff/font.cc
@@ -25,6 +25,7 @@
 #include <assert.h>
 #include <math.h>
 #include <stdlib.h>
+#include "encoding.h" // XXX: ukai
 #include "errarg.h"
 #include "error.h"
 #include "cset.h"
@@ -43,6 +44,9 @@
   int italic_correction;
   int subscript_correction;
   char *special_device_coding;
+#ifdef NIPPON
+  char *subfont_name;
+#endif
 };
 
 struct font_kern_list {
@@ -397,6 +401,14 @@
   return( ch[ch_index[c]].special_device_coding );
 }
 
+#ifdef	NIPPON
+const char *font::get_subfont_name(int c)
+{
+  assert(c >= 0 && c < nindices && ch_index[c] >= 0);
+  return ch[ch_index[c]].subfont_name;
+}
+#endif
+
 void font::alloc_ch_index(int index)
 {
   if (nindices == 0) {
@@ -542,7 +554,7 @@
 	fgets(line, 254, f);
 	fclose(f);
 	test_file = 0;
-	char *linep = line;
+	char *linep = strchr(line, '\0');
 	// skip final newline, if any
 	if (*(--linep) == '\n')
 	  *linep = '\0';
@@ -554,12 +566,17 @@
   return 0;
 }
 
+
 // If the font can't be found, then if not_found is non-NULL, it will be set
 // to 1 otherwise a message will be printed.
 
+
 int font::load(int *not_found)
 {
   char *path;
+#ifdef NIPPON
+  int had_fixedkanji = 0;
+#endif
   FILE *fp;
   if ((fp = open_file(name, &path)) == NULL) {
     if (not_found)
@@ -630,6 +647,60 @@
     else if (strcmp(p, "special") == 0) {
       special = 1;
     }
+#ifdef NIPPON
+    else if (strcmp(p, "fixedkanji") == 0) {
+      font_char_metric metric;
+      int last_index;
+
+      had_fixedkanji = 1;
+
+      metric.height = 0;
+      metric.depth = 0;
+      metric.pre_math_space = 0;
+      metric.italic_correction = 0;
+      metric.subscript_correction = 0;
+      metric.special_device_coding = NULL;
+      metric.subfont_name = NULL;
+      p = strtok(0, WS);
+      if (p == 0) {
+	  t.error("missing metric infomation");
+	  return 0;
+      }
+      int nparms = sscanf(p, "%d,%d,%d,%d,%d,%d",
+			  &metric.width, &metric.height, &metric.depth,
+			  &metric.italic_correction,
+			  &metric.pre_math_space,
+			  &metric.subscript_correction);
+      if (nparms < 1) {
+	  t.error("bad width");
+	  return 0;
+      }
+      p = strtok(0, WS);
+      if (p == 0) {
+	  t.error("missing character type");
+	  return 0;
+      }
+      int type;
+      if (sscanf(p, "%d", &type) != 1) {
+	  t.error("bad character type");
+	  return 0;
+      }
+      if (type < 0 || type > 255) {
+	  t.error("character type `%1' out of range", type);
+	  return 0;
+      }
+      metric.type = type;
+
+      wchar wc;
+
+      for (encoding->wchar_iter_first(&wc); encoding->wchar_iter_next(&wc);) {
+	metric.code = wc;
+	last_index = wchar_index(wc);
+	add_entry(last_index, metric);
+	copy_entry(number_to_index(metric.code), last_index);
+      }
+    }
+#endif
     else if (strcmp(p, "kernpairs") != 0 && strcmp(p, "charset") != 0) {
       char *command = p;
       p = strtok(0, "\n");
@@ -680,6 +751,10 @@
       }
     }
     else if (strcmp(command, "charset") == 0) {
+#ifdef	NIPPON
+      if (had_fixedkanji)
+	goto end;
+#endif
       had_charset = 1;
       int last_index = -1;
       for (;;) {
@@ -718,6 +793,10 @@
 	  metric.pre_math_space = 0;
 	  metric.italic_correction = 0;
 	  metric.subscript_correction = 0;
+#ifdef NIPPON
+	  metric.special_device_coding = NULL;
+	  metric.subfont_name = NULL;
+#endif
 	  int nparms = sscanf(p, "%d,%d,%d,%d,%d,%d",
 			      &metric.width, &metric.height, &metric.depth,
 			      &metric.italic_correction,
@@ -747,6 +826,16 @@
 	    t.error("missing code for `%1'", nm);
 	    return 0;
 	  }
+#ifdef	NIPPON
+	  char *subp = strchr(p, ':');
+	  if (subp) {
+	    *subp++ = '\0';
+	    metric.subfont_name = new char[strlen(subp) + 1];
+	    strcpy(metric.subfont_name, subp);
+	  } else {
+	    metric.subfont_name = NULL;
+	  }
+#endif
 	  char *ptr;
 	  metric.code = (int)strtol(p, &ptr, 0);
 	  if (metric.code == 0 && ptr == p) {
@@ -791,6 +880,9 @@
     t.error("missing charset command");
     return 0;
   }
+#ifdef	NIPPON
+ end:
+#endif
   if (space_width == 0)
     space_width = scale_round(unitwidth, res, 72*3*sizescale);
   compact();
@@ -811,6 +903,11 @@
   { "biggestfont", &font::biggestfont },
   { "spare2", &font::spare2 },
   { "sizescale", &font::sizescale }
+#ifdef	NIPPON
+  ,
+  { "lowerwchar", &font::lowerwchar },
+  { "wcharkern", &font::wcharkern }
+#endif
   };
 
 int font::load_desc()
@@ -888,16 +985,22 @@
 	t.error("papersize command requires an argument");
 	return 0;
       }
-      double unscaled_paperwidth, unscaled_paperlength;
-      if (!scan_papersize(p, &papersize, &unscaled_paperlength,
-			  &unscaled_paperwidth)) {
+      int found_paper = 0;
+      while (p) {
+	double unscaled_paperwidth, unscaled_paperlength;
+	if (scan_papersize(p, &papersize, &unscaled_paperlength,
+			   &unscaled_paperwidth)) {
+	  paperwidth = int(unscaled_paperwidth * res + 0.5);
+	  paperlength = int(unscaled_paperlength * res + 0.5);
+	  found_paper = 1;
+	  break;
+	}
+	p = strtok(0, WS);
+      }
+      if (!found_paper) {
 	t.error("bad paper size");
 	return 0;
       }
-      else {
-	paperwidth = int(unscaled_paperwidth * res + 0.5);
-	paperlength = int(unscaled_paperlength * res + 0.5);
-      }
     }
     else if (strcmp("pass_filenames", p) == 0)
       pass_filenames = 1;
@@ -975,6 +1078,24 @@
       tcommand = 1;
     else if (strcmp("use_charnames_in_special", p) == 0)
       use_charnames_in_special = 1;
+#ifdef	NIPPON
+    else if (strcmp("ondemand", p) == 0) { 
+      int table_size = 3;	// enough room for M and G.
+      on_demand_fonts = (const char **)new char *[table_size];
+      for (int j = 0; j < table_size; j++)
+	on_demand_fonts[j] = 0;
+      int i = 0;
+      for (;;) {
+	p = strtok(0, WS);
+	if (p == 0)
+	  break;
+	assert(i + 1 < table_size);	// scamped work  *^_^*
+	char *tem = new char[strlen(p) + 1];
+	strcpy(tem, p);
+	on_demand_fonts[i++] = tem;
+      }
+    }
+#endif
     else if (strcmp("charset", p) == 0)
       break;
     else if (unknown_desc_command_handler) {
--- groff-1.18.orig/src/libs/libgroff/fontfile.cc
+++ groff-1.18/src/libs/libgroff/fontfile.cc
@@ -24,6 +24,7 @@
 #include <assert.h>
 #include <stdlib.h>
 #include <errno.h>
+#include "encoding.h" // XXX: ukai
 #include "font.h"
 #include "searchpath.h"
 #include "device.h"
@@ -36,6 +37,10 @@
 int font::res = 0;
 int font::hor = 1;
 int font::vert = 1;
+#ifdef	NIPPON
+int font::lowerwchar = 0;
+int font::wcharkern = 0;
+#endif
 int font::unitwidth = 0;
 int font::paperwidth = 0;
 int font::paperlength = 0;
@@ -50,6 +55,9 @@
 int *font::sizes = 0;
 const char *font::family = 0;
 const char **font::style_table = 0;
+#ifdef	NIPPON
+const char **font::on_demand_fonts = 0;
+#endif
 FONT_COMMAND_HANDLER font::unknown_desc_command_handler = 0;
 
 void font::command_line_font_dir(const char *dir)
--- groff-1.18.orig/src/libs/libgroff/nametoindex.cc
+++ groff-1.18/src/libs/libgroff/nametoindex.cc
@@ -24,6 +24,7 @@
 #include <ctype.h>
 #include <assert.h>
 #include <stdlib.h>
+#include "encoding.h" // XXX: ukai
 #include "errarg.h"
 #include "error.h"
 #include "font.h"
@@ -37,6 +38,9 @@
   character_indexer();
   ~character_indexer();
   int ascii_char_index(unsigned char);
+#ifdef	NIPPON
+  int wchar_index(wchar);
+#endif
   int named_char_index(const char *);
   int numbered_char_index(int);
 private:
@@ -68,6 +72,15 @@
   return ascii_index[c];
 }
 
+#ifdef	NIPPON
+int character_indexer::wchar_index(wchar wc)
+{
+  if (encoding->wchar_index(wc) < 0)
+    encoding->set_wchar_index(wc, next_index++);
+  return encoding->wchar_index(wc);
+}
+#endif
+
 int character_indexer::numbered_char_index(int n)
 {
   if (n >= 0 && n < NSMALL) {
@@ -103,6 +116,15 @@
 int font::name_to_index(const char *s)
 {
   assert(s != 0 && s[0] != '\0' && s[0] != ' ');
+#ifdef	NIPPON
+ {
+   int i = 1;
+   wchar wc = encoding->make_wchar(s[0], (const unsigned char *)s, &i);
+   if (encoding->is_wchar_code(wc)) {
+    return indexer.wchar_index(wc);
+   }
+ }
+#endif
   if (s[1] == '\0')
     return indexer.ascii_char_index(s[0]);
   /* char128 and \200 are synonyms */
@@ -115,3 +137,9 @@
   return indexer.named_char_index(s);
 }
 
+#ifdef	NIPPON
+int font::wchar_index(wchar wc)
+{
+  return indexer.wchar_index(wc);
+}
+#endif
--- groff-1.18.orig/src/libs/libgroff/searchpath.cc
+++ groff-1.18/src/libs/libgroff/searchpath.cc
@@ -19,6 +19,7 @@
 with groff; see the file COPYING.  If not, write to the Free Software
 Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
 
+#include "encoding.h"
 #include "lib.h"
 
 #include <stdlib.h>
--- groff-1.18.orig/src/libs/libgroff/tmpfile.cc
+++ groff-1.18/src/libs/libgroff/tmpfile.cc
@@ -24,6 +24,7 @@
 #include <errno.h>
 #include <stdlib.h>
 
+#include "encoding.h"
 #include "posix.h"
 #include "errarg.h"
 #include "error.h"
--- groff-1.18.orig/src/libs/libgroff/encoding.cc
+++ groff-1.18/src/libs/libgroff/encoding.cc
@@ -0,0 +1,234 @@
+// -*- C++ -*-
+/* Copyright (C) 2001 Fumitoshi UKAI <ukai@debian.or.jp>
+
+This file is part of groff.
+
+groff is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2, or (at your option) any later
+version.
+
+groff is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+
+#include "encoding.h"
+#include <string.h>
+#ifdef NIPPON
+#include <locale.h>
+#if HAVE_LANGINFO_CODESET
+#include <langinfo.h>
+#else
+#include <stdlib.h>
+#endif
+#endif
+
+class ascii8_handler : public encoding_handler {
+public:
+  ascii8_handler() {}
+  ~ascii8_handler() {}
+
+  inline int is_wchar_code(wchar wc) { return 0; }
+  inline int is_wchar_byte(unsigned char c) { return 0; }
+
+  inline wchar make_wchar(unsigned char c0, encoding_istream& in) {
+    return wchar(c0);
+  }
+  inline int put_wchar(wchar wc, encoding_ostream& out) {
+    out.putbyte((unsigned char)wc);
+    return 1;
+  }
+  inline int max_wchar_len() { return 1; };
+
+  inline void foreach_wchar(void (*iter)(wchar wc, void *arg), void *arg) {
+    return;
+  }
+  inline int wchar_iter_first(wchar *wc) {
+    return 0;
+  }
+  inline int wchar_iter_next(wchar *wc) {
+    return 0;
+  }
+
+  inline int wchar_index(wchar wc) {
+    return 0;
+  }
+
+  inline void set_wchar_index(wchar wc, int index) {
+    return;
+  }
+
+  inline int wchar_table_index(wchar wc) { return 0; }
+  inline void* init_table() { return NULL;  }
+};
+
+#ifdef NIPPON
+class euc_handler : public encoding_handler {
+  static const int WCTABLE_OFFSET = 0xa1;
+  static const int WCTABLE_SIZE = 94;
+  static const int EUCMASK = 0x8080;
+
+private:
+  int euc_index[WCTABLE_SIZE][WCTABLE_SIZE];
+  int iter_ku, iter_ten;
+
+public:
+  euc_handler() {
+    for (int i = 0; i < WCTABLE_SIZE; i++) {
+      for (int j = 0; j < WCTABLE_SIZE; j++) {
+	euc_index[i][j] = -1;
+      }
+    }
+  };
+  ~euc_handler() {};
+
+  inline int is_wchar_code(wchar wc) {
+    return ((wc & EUCMASK) == (wchar)EUCMASK);
+  }
+
+  inline int is_wchar_byte(unsigned char c) {
+    return (c >= 0xa1 && c <= 0xfe);
+  }
+
+  inline wchar make_wchar(unsigned char c0, encoding_istream& in) {
+    wchar wc;
+    if (! is_wchar_byte(c0)) {
+      return c0;
+    }
+    int c1 = in.peekbyte();
+    if (! is_wchar_byte(c1)) {
+      return c0;
+    }
+    c1 = in.getbyte();
+    wc = (c0 & 0xff) << 8;
+    wc |= (c1 & 0xff);
+
+    if (wc == 0xa1a1)
+      wc = ' ';
+    return wc;
+  }
+
+  inline int put_wchar(wchar wc, encoding_ostream& out) {
+    if (is_wchar_code(wc)) {
+      out.putbyte((wc >> 8) & 0x0ff);
+      out.putbyte((wc >> 0) & 0x0ff);
+      return 2;    
+    } else {
+      out.putbyte(wc & 0x0ff);
+      return 1;
+    }
+  }
+  inline int max_wchar_len() { return 2; }; /* XXX */
+
+  inline void foreach_wchar(void (*iter)(wchar wc, void *arg), void *arg) {
+    int ku, ten;
+    wchar wc;
+    for (ku = 0; ku < WCTABLE_SIZE; ku++) {
+      for (ten = 0; ten < WCTABLE_SIZE; ten++) {
+	wc = 0;
+	wc = ((ku + WCTABLE_OFFSET) << 8) & 0xff00;
+	wc |= (ten + WCTABLE_OFFSET) & 0xff;
+	iter(wc, arg);
+      }
+    }
+  }
+  inline int wchar_iter_first(wchar *wc) {
+    iter_ku = iter_ten = 0;
+    *wc = 0;
+    *wc = ((iter_ku + WCTABLE_OFFSET) << 8) & 0xff00;
+    *wc |= (iter_ten + WCTABLE_OFFSET) & 0xff;
+    return 1;
+  }
+  inline int wchar_iter_next(wchar *wc) {
+    *wc = 0;
+    iter_ten++;
+    if (iter_ten >= WCTABLE_SIZE) {
+      iter_ten = 0; 
+      iter_ku++;
+      if (iter_ku >= WCTABLE_SIZE) {
+	return 0;
+      }
+    }
+    *wc = ((iter_ku + WCTABLE_OFFSET) << 8) & 0xff00;
+    *wc |= (iter_ten + WCTABLE_OFFSET) & 0xff;
+    return 1;
+  }
+
+  inline int wchar_index(wchar wc) {
+    int ku = ((wc >> 8) & 0xff) - WCTABLE_OFFSET;
+    int ten = (wc & 0xff) - WCTABLE_OFFSET;
+    return euc_index[ku][ten];
+  }
+
+  inline void set_wchar_index(wchar wc, int index) {
+    int ku = ((wc >> 8) & 0xff) - WCTABLE_OFFSET;
+    int ten = (wc & 0xff) - WCTABLE_OFFSET;
+    euc_index[ku][ten] = index;
+  }
+
+  inline int wchar_table_index(wchar wc) {
+    int ku = ((wc >> 8) & 0xff) - WCTABLE_OFFSET;
+    int ten = (wc & 0xff) - WCTABLE_OFFSET;
+    return ku * WCTABLE_SIZE + ten;
+  }
+  inline void* init_table() { 
+    void *tbl = new void*[WCTABLE_SIZE * WCTABLE_SIZE];
+    memset(tbl, 0, WCTABLE_SIZE * WCTABLE_SIZE);
+    return tbl;
+  }
+};
+#endif
+
+static ascii8_handler ascii8;
+#ifdef NIPPON
+static euc_handler eucjp;
+#endif
+
+encoding_handler *encoding = &ascii8;
+
+encoding_handler *
+new_encoding_handler(const char *encoding_name)
+{
+#ifdef NIPPON
+  // printf("encoding request: [%s]\n", encoding_name);
+  if (strcmp(encoding_name, "EUC-JP") == 0) {
+    // printf("encoding: [EUC-JP]\n");
+    encoding = &eucjp;
+    return &eucjp;
+  }
+#endif
+  // default
+  encoding = &ascii8;
+  return &ascii8;
+}
+
+encoding_handler *
+init_encoding_handler()
+{
+#ifdef NIPPON
+  const char *locale;
+  setlocale(LC_ALL, "");
+#if HAVE_LANGINFO_CODESET
+  locale = nl_langinfo(CODESET);
+#else
+  /* Emulation taken from gettext's locale_charset() function. */
+  locale = setlocale(LC_CTYPE, NULL);
+  if (locale == NULL || locale[0] == '\0') {
+    locale = getenv("LC_ALL");
+    if (locale == NULL || locale[0] == '\0') {
+      locale = getenv("LC_CTYPE");
+      if (locale == NULL || locale[0] == '\0')
+	locale = getenv("LANG");
+    }
+  }
+#endif
+  new_encoding_handler(locale);
+#endif
+
+  return encoding;
+}
--- groff-1.18.orig/src/libs/libdriver/input.cc
+++ groff-1.18/src/libs/libdriver/input.cc
@@ -250,6 +250,7 @@
 
 #include "driver.h"
 #include "device.h"
+#include "encoding.h"
 
 #include <stdlib.h>
 #include <errno.h>
@@ -1512,6 +1513,17 @@
   return stopped;
 }
 
+////////////////////////////////////////////////////////////////
+#ifdef	NIPPON
+class encoding_istream_current_file : public encoding_istream {
+public:
+  encoding_istream_current_file() {};
+  ~encoding_istream_current_file() {};
+  int getbyte() { return getc(current_file); };
+  int peekbyte() { int ch = getc(current_file); ungetc(ch, current_file); return ch; };
+  void ungetbyte(int c) { ungetc(c, current_file); };
+};
+#endif
 
 /**********************************************************************
                      exported part (by driver.h)
@@ -1758,6 +1770,16 @@
 	size_t i = 0;
 	while ((c = str_arg[i++]) != '\0') {
 	  EnvInt w;
+#ifdef	NIPPON
+ 	  if (encoding->is_wchar_byte(c)) {
+ 	    wchar wc = encoding->make_wchar(c, (const unsigned char *)str_arg, (int *)&i);
+ 	    if (encoding->is_wchar_code(wc)) {
+ 	      pr->set_wchar_char(wc, current_env, &w);
+ 	    } else {
+ 	      pr->set_ascii_char((unsigned char) c, current_env, &w);
+ 	    }
+ 	  } else
+#endif
 	  pr->set_ascii_char((unsigned char) c, current_env, &w);
 	  current_env->hpos += w;
 	}
--- groff-1.18.orig/src/libs/libdriver/printer.cc
+++ groff-1.18/src/libs/libdriver/printer.cc
@@ -27,6 +27,7 @@
 */
 
 #include "driver.h"
+#include "encoding.h"
 
 printer *pr = 0;
 
@@ -137,6 +138,19 @@
     *widthp = w;
   }
 }
+
+#ifdef	NIPPON
+void printer::set_wchar_char(wchar c, const environment *env, int *widthp)
+{
+  int len = encoding->max_wchar_len() + 1;
+  unsigned char *buf = new unsigned char[len];
+  memset(buf, 0, len);
+  int i = 0;
+  encoding->put_wchar(c, buf, &i, len);
+  set_special_char((const char *)buf, env, widthp);
+  delete [] buf;
+}
+#endif
 
 void printer::set_special_char(const char *nm, const environment *env,
 			       int *widthp)
--- groff-1.18.orig/src/roff/groff/groff.cc
+++ groff-1.18/src/roff/groff/groff.cc
@@ -106,6 +106,7 @@
   program_name = argv[0];
   static char stderr_buf[BUFSIZ];
   setbuf(stderr, stderr_buf);
+  init_encoding_handler();
   assert(NCOMMANDS <= MAX_COMMANDS);
   string Pargs, Largs, Fargs;
   int vflag = 0;
--- groff-1.18.orig/src/roff/groff/groff.man
+++ groff-1.18/src/roff/groff/groff.man
@@ -948,6 +948,10 @@
 Text output using the EBCDIC code page IBM cp1047 (e.g. OS/390 Unix).
 .
 .TP
+.B nippon
+Text output using the Japanese-EUC character set.
+.
+.TP
 .B dvi
 TeX DVI format.
 .
@@ -955,6 +959,12 @@
 .B html
 HTML output.
 .
+.TP
+.B ascii8
+For typewriter-like devices.  Unlike
+.BR ascii ,
+this device is 8 bit clean.  This device is intended to be used
+for codesets other than ASCII and ISO-8859-1.
 .TP
 .B latin1
 Text output using the ISO Latin-1 (ISO 8859-1) character set; see
--- groff-1.18.orig/src/roff/groff/pipeline.h
+++ groff-1.18/src/roff/groff/pipeline.h
@@ -24,7 +24,7 @@
 #endif
 
 /* run_pipeline can handle at most this many commands */
-#define MAX_COMMANDS 10
+#define MAX_COMMANDS 12
 
 /* Children exit with this status if execvp fails. */
 #define EXEC_FAILED_EXIT_STATUS 0xff
--- groff-1.18.orig/src/roff/troff/charinfo.h
+++ groff-1.18/src/roff/troff/charinfo.h
@@ -29,9 +29,16 @@
   macro *mac;
   unsigned char special_translation;
   unsigned char hyphenation_code;
+#ifdef NIPPON
+  unsigned short flags;
+#else
   unsigned char flags;
+#endif
   unsigned char ascii_code;
   unsigned char asciify_code;
+#ifdef NIPPON
+  wchar wchar_code;
+#endif
   char not_found;
   char transparent_translate;	// non-zero means translation applies
 				// to transparent throughput
@@ -47,6 +54,11 @@
     OVERLAPS_VERTICALLY = 16,
     TRANSPARENT = 32,
     NUMBERED = 64
+#ifdef	NIPPON
+    ,
+    DONT_BREAK_BEFORE = 0x100,	// 256, pre kinsoku
+    DONT_BREAK_AFTER = 0x200	// 512, post kinsoku
+#endif
     };
   enum {
     TRANSLATE_NONE,
@@ -74,7 +86,11 @@
   int get_translation_input();
   charinfo *get_translation(int = 0);
   void set_translation(charinfo *, int, int);
+#ifdef NIPPON
+  void set_flags(unsigned short);
+#else
   void set_flags(unsigned char);
+#endif
   void set_special_translation(int, int);
   int get_special_translation(int = 0);
   macro *set_macro(macro *, int = 0);
@@ -84,6 +100,12 @@
   int get_number();
   int numbered();
   int is_fallback();
+#ifdef	NIPPON
+  wchar get_wchar_code();
+  void set_wchar_code(wchar);
+  int cannot_break_before(); // pre kinsoku
+  int cannot_break_after(); // post kinsoku
+#endif
   symbol *get_symbol();
 };
 
@@ -131,6 +153,19 @@
   return fallback;
 }
 
+#ifdef	NIPPON
+inline int charinfo::cannot_break_before()
+{
+  return flags & DONT_BREAK_BEFORE;
+}
+
+inline int charinfo::cannot_break_after()
+{
+  return flags & DONT_BREAK_AFTER;
+}
+
+#endif
+
 inline charinfo *charinfo::get_translation(int transparent_throughput)
 {
   return (transparent_throughput && !transparent_translate
@@ -153,7 +188,18 @@
   return (translate_input ? asciify_code : 0);
 }
 
+#ifdef	NIPPON
+inline wchar charinfo::get_wchar_code()
+{
+  return wchar_code;
+}
+#endif
+
+#ifdef	NIPPON
+inline void charinfo::set_flags(unsigned short c)
+#else
 inline void charinfo::set_flags(unsigned char c)
+#endif
 {
   flags = c;
 }
